/*****************************************************************/ 
/*名    称：        I/O口模拟串行通讯底层函数                    */
/*功    能：        利用普通I/O口，模拟串行通讯RS232             */
/*芯片类型：        AT89S51                                      */
/*晶振频率：        11.0592MHZ                                   */ 
/*作    者：        救火车                                       */
/*版    权：        http://www.qm999.cn                          */
/*编写日期：        2009-12-28                                    */
/*****************************************************************/
#define TXD1  P3_4	//定义模拟输出脚
#define RXD1  P3_3  //定义模拟输入脚

bdata unsigned char SBUF1;   //定义一个位操作变量
sbit SBUF1_bit0 = SBUF1^0;
sbit SBUF1_bit1 = SBUF1^1;
sbit SBUF1_bit2 = SBUF1^2;
sbit SBUF1_bit3 = SBUF1^3;
sbit SBUF1_bit4 = SBUF1^4;
sbit SBUF1_bit5 = SBUF1^5;
sbit SBUF1_bit6 = SBUF1^6;
sbit SBUF1_bit7 = SBUF1^7;

//void delay_bps() {unsigned char i; for (i = 0; i < 13; i++);} //波特率19200
void delay_bps() {unsigned char i; for (i = 0; i < 29; i++); _nop_();_nop_();} //波特率9600
//void delay_bps() {unsigned char i; for (i = 0; i < 61; i++);} //波特率4800

/*
#define RX_BUFFER_SIZE2 40 
unsigned char rx_buffer2[RX_BUFFER_SIZE2];   //接收缓冲区
unsigned char rx_rd_index2 = 0;   //读指针
unsigned char rx_wd_index2 = 0;   //写入指针
unsigned char rx_counter2 = 0;  //缓冲区内数据字节个数 
*/
//void receive_byte(void)    //从缓冲区内读取一个字节数据
unsigned char getchar2()	//从缓冲区内读取一个字节数据
{
	while (RXD1);
    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();
    delay_bps();
    SBUF1_bit0 = RXD1; //0       
    delay_bps();
    SBUF1_bit1 = RXD1; //1       
    delay_bps();
    SBUF1_bit2 = RXD1; //2       
    delay_bps();
    SBUF1_bit3 = RXD1; //3       
    delay_bps();
    SBUF1_bit4 = RXD1; //4       
    delay_bps();
    SBUF1_bit5 = RXD1; //5       
    delay_bps();
    SBUF1_bit6 = RXD1; //6       
    delay_bps();
    SBUF1_bit7 = RXD1; //7       
	delay_bps();
    return(SBUF1) ;      //返回读取的数据
//	if(rx_counter2<RX_BUFFER_SIZE2)
//	{
//		rx_counter2++;                //字节个数 +1
//		rx_buffer2[rx_wd_index2]=SBUF1; //数据转存到接收缓冲区
//		if(++rx_wd_index2==RX_BUFFER_SIZE2) rx_wd_index2=0;
//	} 

}
/*
//从模拟串口缓冲区读取一个字节的数据
unsigned char getchar2()
{
unsigned char ret;
if(rx_counter2>0)     //如果缓冲内有数据
{
    ret=rx_buffer2[rx_rd_index2];    //读取一个数据
    if(++rx_rd_index2==RX_BUFFER_SIZE2) rx_rd_index2=0;  //判断读指针是否超出范围
    --rx_counter2;      //缓冲区内数据字节数-1

}
return ret;      //返回读取的数据
}
*/

void putchar2(unsigned char input)    //向发送缓冲区内写入一个数据
{
    SBUF1 = input;
    TXD1 = 0;  //起始位
    delay_bps();    
    TXD1 = SBUF1_bit0;  //0
    delay_bps();    
    TXD1 = SBUF1_bit1;  //1
    delay_bps();    
    TXD1 = SBUF1_bit2;  //2
    delay_bps();    
    TXD1 = SBUF1_bit3;  //3
    delay_bps();    
    TXD1 = SBUF1_bit4;  //4
    delay_bps();    
    TXD1 = SBUF1_bit5;  //5
    delay_bps();    
    TXD1 = SBUF1_bit6;  //6
    delay_bps();    
    TXD1 = SBUF1_bit7;  //7
    delay_bps();    
    TXD1 = 1;       //停止位
    delay_bps();    
}


